您的位置:首页 > 其它

POJ 3126 Prime Path (bfs、埃氏筛法)

2015-03-31 20:14 363 查看
Prime Path

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 12750 Accepted: 7219
Description


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 

— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened. 

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 

— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 

— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033

1733

3733

3739

3779

8779

8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033

Sample Output
6
7
0


先给素数打表 然后确定状态转移 bfs即可

AC代码如下:

//
// POJ 3126 Prime Path
//
// Created by TaoSama on 2015-03-23
// Copyright (c) 2015 TaoSama. All rights reserved.
//
#include <algorithm>
#include <cctype>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <string>
#include <set>
#include <vector>
#define CLR(x,y) memset(x, y, sizeof(x))

using namespace std;
const int INF = 0x3f3f3f3f;
const int MOD = 1e9 + 7;
const int N = 1e5 + 10;

int n, s, g, dp[10005];
bool prime[10005], in[10005];
void seive() {
memset(prime, true, sizeof prime);
prime[0] = prime[1] = false;
for(int i = 2; i < 10000; ++i) {
if(prime[i]) {
for(int j = i + i; j < 10000; j += i)
prime[j] = false;
}
}
}
int bfs() {
memset(dp, 0x3f, sizeof dp);
memset(in, false, sizeof in);
queue<int> q;
dp[s] = 0; in[s] = true; q.push(s);
while(!q.empty()) {
int cur = q.front(), nxt; q.pop();
// cout << "cur: " << cur << endl;
for(int i = 0; i < 4 ; ++i) {
char s[5]; sprintf(s, "%d", cur);
if(i == 0) s[i] = '1' - 1;
else if(i == 3) s[i] = '1' - 2;
else s[i] = '0' - 1;
// cout << ' ' << "s: " << s << endl;
while(s[i] < '9') {
if(i == 3) s[i] += 2;
else ++s[i];
nxt = atoi(s);
if(prime[nxt] && !in[nxt]) {
if(dp[nxt] > dp[cur] + 1) {
dp[nxt] = dp[cur] + 1;
q.push(nxt); in[nxt] = true;
// cout << "nxt: " << nxt << ' ' << dp[nxt] << endl;
}
}
}
}
}
return dp[g];
}
int main() {
#ifdef LOCAL
freopen("ACM_in.txt", "r", stdin);
// freopen("ACM_out.txt", "w", stdout);
#endif
ios_base::sync_with_stdio(0);
seive();
while(cin >> n) {
for(int i = 1; i <= n; ++i) {
cin >> s >> g;
int ans = bfs();
if(ans == INF) cout << "Impossible" << endl;
else cout << ans << endl;
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: